{
  config,
  pkgs,
  lib,
  ...
}:

{
  imports = [
    ../../modules/base-server.nix

    ./services/postgres.nix
    ./services/matrix/root.nix
    ./services/nginx/nginx.nix
  ];
  networking = {
    hostName = "matrix";
    interfaces.ens18.ipv4.addresses = [
      {
        address = "10.10.0.3";
        prefixLength = 8;
      }
    ];
    defaultGateway.interface = "ens18";
  };

  hardware.enableAllFirmware = false;
  hardware.enableRedistributableFirmware = false;
  system.stateVersion = "22.11"; # DO NOT EDIT!
}
